local tables = {
    AchievementListGui,
    ChatGui,
    ContractBrokerGui,
    HUDChat,
    MenuItemInput
}

for _, t in ipairs(tables) do
    local key_press = t.key_press or t.search_key_press
    local key_release = t.key_release or t.search_key_release
    local enter_text = t.enter_text

    t[t.key_press and "key_press" or "search_key_press"] = function(self, o, k)
        if MenuItemTextBox:_ctrl() and k == Idstring("v") then
            k = Idstring("insert")
        end

        key_press(self, o, k)
    end

    t[t.key_release and "key_release" or "search_key_release"] = function(self, o, k)
        if MenuItemTextBox:_ctrl() and k == Idstring("v") then
            k = Idstring("insert")
        end

        key_release(self, o, k)
    end

    t.enter_text = function(self, ...)
        if not MenuItemTextBox:_ctrl() then
            enter_text(self, ...)
        end
    end
end

_G.mitw153_ctrl_v = true